/*
 * config.h
 *
 *  Created on: 07.03.2013
 *      Author: AndreR
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#include "stm32f10x.h"

#include "hal/eeprom.h"
#include "wifi.h"

typedef struct _Config
{
	EEPROM eeprom;

	union
	{
		struct _values
		{
			uint8_t magic;			// magic byte to check eeprom content

			IPv4Address ip;
			uint8_t channel;		// frequency
			uint8_t speed;
			uint8_t maxRt;
			uint8_t maxVisionRate;
			uint16_t ackDelayUs;
			uint16_t port;		// local UDP RX port
			uint16_t maxNoLinkTries;
		} values;

		uint8_t _data[sizeof(struct _values)];
	};
} Config;

extern Config config;

void ConfigInit();
int16_t ConfigSave();
void ConfigReset();

#endif /* CONFIG_H_ */
