/*
 * rtos_hf_timer.c
 *
 *  Created on: 17.01.2013
 *      Author: AndreR
 */

#include "rtos_hf_timer.h"

#include "FreeRTOS.h"

#include "stm32f10x.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_tim.h"
#include "misc.h"

volatile uint32_t rtosHfTickCount = 0;

void TIM2_IRQHandler()
{
	TIM2->SR = 0;

	rtosHfTickCount++;
}

void RTOSHFTimerInit()
{
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

	TIM_TimeBaseInitTypeDef timeBaseInit;
	timeBaseInit.TIM_ClockDivision = TIM_CKD_DIV1;
	timeBaseInit.TIM_CounterMode = TIM_CounterMode_Up;
	timeBaseInit.TIM_Period = 20;	// 50kHz
	timeBaseInit.TIM_Prescaler = 71;	// 71 = 1us
	timeBaseInit.TIM_RepetitionCounter = 0;
	TIM_TimeBaseInit(TIM2, &timeBaseInit);

	TIM_ARRPreloadConfig(TIM2, DISABLE);

	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);

	NVIC_InitTypeDef nvicInit;
	nvicInit.NVIC_IRQChannel = TIM2_IRQn;
	nvicInit.NVIC_IRQChannelCmd = ENABLE;
	nvicInit.NVIC_IRQChannelPreemptionPriority = configLIBRARY_KERNEL_INTERRUPT_PRIORITY-1;
	nvicInit.NVIC_IRQChannelSubPriority = 0;
	NVIC_Init(&nvicInit);

	TIM_Cmd(TIM2, ENABLE);
}
