/*
 * linked_list.h
 *
 *  Created on: 24.04.2013
 *      Author: AndreR
 */

#ifndef LINKED_LIST_H_
#define LINKED_LIST_H_

#include "stm32f10x.h"

typedef struct _LinkedListEntry
{
	struct _LinkedListEntry* pNext;
	struct _LinkedListEntry* pPrevious;
} LinkedListEntry;

typedef struct _LinkedList
{
	LinkedListEntry* pHead;
	LinkedListEntry* pTail;
} LinkedList;

typedef uint8_t(*LinkedListCompareFunc)(void* pData, void* pUserData);

void LinkedListInit(LinkedList* pList);
void LinkedListPushBack(LinkedList* pList, void* pData);
void* LinkedListPopFront(LinkedList* pList);
void* LinkedListFind(LinkedList* pList, LinkedListCompareFunc pCompare, void* pUserData);
void LinkedListRemove(LinkedList* pList, void* pData);


#endif /* LINKED_LIST_H_ */
