/*
 * dect.h
 *
 *  Created on: 01.07.2010
 *      Author: AndreR
 */

#ifndef __NETWORK_H__
#define __NETWORK_H__

#include "util/fifo_packet_synced.h"
#include "util/nrf24.h"

#include "constants.h"
#include "commands.h"

#include "FreeRTOS.h"
#include "semphr.h"

#define PACKET_HEADER_SIZE 4
typedef union _PacketHeader
{
	struct
	{
		uint8_t cmd;
		uint8_t section;
		uint16_t len;   // data length only
	};

	uint8_t _data[PACKET_HEADER_SIZE];
} PacketHeader;

typedef void(*PosCallback)();

typedef struct _Network
{
	uint8_t txProcessingBuf[NETWORK_TX_PROCESSING_SIZE];
	uint8_t rxProcessingBuf[NETWORK_RX_PROCESSING_SIZE];

	SystemConsolePrint netPrint;

	xSemaphoreHandle hNewPacket;
	xSemaphoreHandle hSendPacket;
	xSemaphoreHandle hPrintMutex;

	uint32_t cpuId[3];

	uint8_t botId;

	uint8_t enableTimeout;

	NRF24 nrf24;

	PosCallback posCb;

	int16_t lastVisionPos[3];
} Network;

extern Network network;

void	NetworkInit();
int16_t	NetworkSendPacket(PacketHeader* pHeader, uint8_t* pData);
void	NetworkSetPosCallback(PosCallback cb);
int32_t NetworkPrint(const char* fmt, ...);

#endif /* DECT_H_ */
