/*
 * crc.c
 *
 *  Created on: 06.06.2013
 *      Author: AndreR
 */

#include "crc.h"

#include "stm32f4xx_rcc.h"
#include "stm32f4xx_crc.h"

void CRCInit()
{
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_CRC, ENABLE);
}

uint32_t CRC32Checksum(uint32_t* pData, uint32_t dataLength)
{
	CRC_ResetDR();

	uint32_t index = 0;

	for(index = 0; index < dataLength; index++)
	{
		CRC->DR = __RBIT(pData[index]);
	}

	return (__RBIT(CRC->DR) ^ 0xFFFFFFFF);
}
