/*
 * fifo8_synced.h
 *
 *  Created on: 25.05.2011
 *      Author: AndreR
 */

#ifndef __FIFO8_SYNCED_H__
#define __FIFO8_SYNCED_H__

#include "stm32f4xx.h"

typedef uint8_t(*FifoSyncedLockCallback)(void*);
typedef void(*FifoSyncedReleaseCallback)(uint8_t, void*);

typedef struct _FifoSynced
{
	volatile uint8_t*	pWrite;
	volatile uint8_t*	pRead;
	uint8_t*	pData;
	uint8_t*	pDataEnd;

	uint16_t	Size;
	volatile uint16_t	EmptyBytes;

	void* syncData;

	FifoSyncedLockCallback lockCallback;
	FifoSyncedReleaseCallback releaseCallback;
} FifoSynced;


void	FifoSyncedInit(FifoSynced* pFIFO, uint8_t* pData, uint16_t Size, FifoSyncedLockCallback lockCb, FifoSyncedReleaseCallback releaseCb);
void	FifoSyncedClear(FifoSynced* pFIFO);
int16_t	FifoSyncedPushByte(FifoSynced* pFIFO, uint8_t Byte);
int16_t	FifoSyncedPopByte(FifoSynced* pFIFO, uint8_t* pByte);
int16_t	FifoSyncedPush(FifoSynced* pFifo, uint16_t length, uint8_t* pData);
int16_t	FifoSyncedPop(FifoSynced* pFifo, uint16_t length, uint8_t* pData, uint16_t* pBytesRead);


#endif
