/*
 * hw_sync.c
 *
 *  Created on: 16.12.2012
 *      Author: AndreR
 */

#include "hw_sync.h"

#include "FreeRTOS.h"
#include "task.h"

void HWSyncInit(HWSync* pSync, GPIO_TypeDef* pPort, uint32_t pin)
{
	pSync->pPort = pPort;
	pSync->pin = pin;

	for(uint32_t i = 0; i < 16; i++)
	{
		if(pin & (1 << i))
		{
			pSync->pinNumber = i;
			break;
		}
	}

	GPIO_InitTypeDef gpioInit;
	gpioInit.GPIO_Mode = GPIO_Mode_OUT;
	gpioInit.GPIO_OType = GPIO_OType_OD;
	gpioInit.GPIO_PuPd = GPIO_PuPd_UP;
	gpioInit.GPIO_Speed = GPIO_Speed_2MHz;
	gpioInit.GPIO_Pin = pin;
	GPIO_Init(pPort, &gpioInit);

	pPort->BSRRH = pin;
}

void HWSyncBarrier(HWSync* pSync)
{
	// make pin input
	pSync->pPort->MODER &= ~(3 << pSync->pinNumber*2);

	while(42)
	{
		if(pSync->pPort->IDR & pSync->pin)
			break;

		vTaskDelay(2/portTICK_RATE_MS);
	}

	vTaskDelay(10/portTICK_RATE_MS);

	// and output again
	pSync->pPort->MODER |= (1 << pSync->pinNumber*2);
}
