/*
 * md5.h
 *
 *  Created on: 03.06.2013
 *      Author: AndreR
 */

#ifndef MD5_H_
#define MD5_H_

#include "stm32f4xx.h"
#include "FreeRTOS.h"
#include "semphr.h"

typedef struct _MD5
{
	xSemaphoreHandle hHashMutex;
	xSemaphoreHandle hDigestComplete;
} MD5;

extern MD5 md5;

/**************************
 * NOTE:
 * MD5 does not work on STM32F40x devices as they do not have a crypto/hash coprocessor.
 */

void MD5Init(uint8_t priority);
void MD5Hash(uint32_t* pData, uint32_t dataLength, uint32_t* pMD5);

#endif /* MD5_H_ */
