/*
 * enc.h
 *
 *  Created on: 27.07.2010
 *      Author: AndreR
 */

#ifndef __ENC__
#define __ENC__

#include "stm32f4xx.h"

typedef void(*NotifyUpdated)();	// called with IRQ context

typedef struct _Encoder
{
	int16_t lastVal[4];

	float angularVelocity[4];	// [rad/s]

	NotifyUpdated pUpdatedCallback;
} Encoder;

extern Encoder encoder;

void	EncInit();
void	EncEnableAutoUpdate(uint8_t enable);
float	EncGetCurrentAngle(uint8_t id);
void	EncZeroAll();
void	EncSetUpdateCallback(NotifyUpdated pCb);

#endif /* ENC_H_ */
