/*
 * constants.h
 *
 *  Created on: 13.02.2011
 *      Author: AndreR
 */

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

/////////////////////////////////////////////////
// Buffer Sizes
/////////////////////////////////////////////////

// SPI
#define SPI3_FIFO_SIZE 1024
#define SPI3_DMA_SIZE 1024
#define SPI3_CB_SIZE 1024

// USART2
#define USART2_FIFO_SIZE 1000
#define USART2_DMA_SIZE 1000

// INTERCOM
#define INTERCOM_PROCESS_SIZE 1000

// CONSOLE
#define CONSOLE_RX_SIZE 300
#define CONSOLE_TX_SIZE 1000
#define CONSOLE_PRINT_SIZE 800
#define CONSOLE_SCAN_SIZE 100

// CONSOLE INTERCOM ADAPTER
#define CONSOLE_INTERCOM_ADAPTER_BUF_SIZE 1000

// CLI
#define CLI_PROC_SIZE 1000

/////////////////////////////////////////////////
// IRQ Levels
/////////////////////////////////////////////////

// USART1
#define IRQL_USART1		12

// USART2
#define IRQL_USART2		11

// SPI
#define IRQL_SPI3		14

// External Interrupts
#define IRQL_EXTI2		14	// Touch event
#define IRQL_EXTI5_9	13
#define IRQL_EXTI10_15	13

// Audio DMA
#define IRQL_AUDIO_DMA	12

#define IRQL_CAM		13

#endif
