/*
 * gui_demo.c
 *
 *  Created on: 06.06.2013
 *      Author: AndreR
 */

#include "gui_demo.h"
#include "gui.h"
#include "util/console.h"

GUITab tab0, tab1, tab2, tab3, tab4, tab5, tab6;

static GUIElement tab0ElementsArray[2];
static GUIElement tab1ElementsArray[1];
static GUIElement tab2ElementsArray[3];
static GUIElement tab3ElementsArray[3];

float settableNumberFloat = 0.0;
uint32_t settableNumberUInt = 0;
int32_t settableNumberInt = 0;

void btn0_1CB(uint8_t inputNumber)
{
	ConsolePrint("Button 1 pressed %hhu\r\n", inputNumber);
}

buttonCB btn1_0CBPtr = &btn0_1CB;

void GUIDemoInit(void)
{
	//  Tab0
	tab0.pTitle = "PWR";

	tab0ElementsArray[0].bGColor = 0x00ff00;
	tab0ElementsArray[0].fGColor = 0xffffff;
	tab0ElementsArray[0].type = ELEMENT_TYPE_INPUT_INT;
	tab0ElementsArray[0].pos = PointU16XY(10, 10);
	tab0ElementsArray[0].inputFieldInt.pValue = &settableNumberInt;
	tab0ElementsArray[0].inputFieldInt.width = 80;

	tab0ElementsArray[1].bGColor = 0x00ff00;
	tab0ElementsArray[1].fGColor = 0xffffff;
	tab0ElementsArray[1].type = ELEMENT_TYPE_BUTTON;
	tab0ElementsArray[1].pos = PointU16XY(200, 150);
	tab0ElementsArray[1].button.size = SizeU16WH(30, 60);

	tab0ElementsArray[1].button.pText = "BTN";
	tab0ElementsArray[1].button.cb = btn1_0CBPtr;

	tab0.numElements = 2;
	tab0.pElements = tab0ElementsArray;
	GUIAddTab(&tab0);


	// Tab1
	tab1.pTitle = "AIR";

	tab1ElementsArray[0].bGColor = 0xff00ff;
	tab1ElementsArray[0].fGColor = 0;
	tab1ElementsArray[0].type = ELEMENT_TYPE_TEXT;
	tab1ElementsArray[0].pos = PointU16XY(0, 0);

	tab1ElementsArray[0].text.pText = "random text";
	tab1.numElements = 1;
	tab1.pElements = tab1ElementsArray;
	GUIAddTab(&tab1);

	// Tab2
	tab2.pTitle = "IR ";
	tab2ElementsArray[0].bGColor = 0xff00;
	tab2ElementsArray[0].fGColor = 0xffffff;
	tab2ElementsArray[0].type = ELEMENT_TYPE_TEXT;
	tab2ElementsArray[0].pos = PointU16XY(50, 52);
	tab2ElementsArray[0].text.pText = "WEIRD";

	tab2ElementsArray[1].bGColor = 0xaffe;
	tab2ElementsArray[1].fGColor = 0x1337;
	tab2ElementsArray[1].type = ELEMENT_TYPE_TEXT;
	tab2ElementsArray[1].pos = PointU16XY(85, 87);
	tab2ElementsArray[1].text.pText = "SMURF";

	tab2ElementsArray[2].bGColor = 0x1248;
	tab2ElementsArray[2].fGColor = 0x3333;
	tab2ElementsArray[2].type = ELEMENT_TYPE_TEXT;
	tab2ElementsArray[2].pos = PointU16XY(110, 112);
	tab2ElementsArray[2].text.pText = "MUD";

	tab2.numElements = 3;
	tab2.pElements = tab2ElementsArray;
	GUIAddTab(&tab2);

	// Tab3
	tab3.pTitle = "CFG";
	tab3ElementsArray[0].bGColor = 0xaa;
	tab3ElementsArray[0].fGColor = 0xbb;
	tab3ElementsArray[0].type = ELEMENT_TYPE_TEXT;
	tab3ElementsArray[0].pos = PointU16XY(10, 17);
	tab3ElementsArray[0].text.pText = "ISCH";

	tab3ElementsArray[1].bGColor = 0xcc;
	tab3ElementsArray[1].fGColor = 0xdd;
	tab3ElementsArray[1].type = ELEMENT_TYPE_TEXT;
	tab3ElementsArray[1].pos = PointU16XY(40, 47);
	tab3ElementsArray[1].text.pText = "HAB";

	tab3ElementsArray[2].bGColor = 0xee;
	tab3ElementsArray[2].fGColor = 0xff;
	tab3ElementsArray[2].type = ELEMENT_TYPE_TEXT;
	tab3ElementsArray[2].pos = PointU16XY(70, 77);
	tab3ElementsArray[2].text.pText = "RUECKEN";

	tab3.numElements = 3;
	tab3.pElements = tab3ElementsArray;
	GUIAddTab(&tab3);

	// Tab4
	tab4.pTitle = "TB5";
	tab4.numElements = 0;
	GUIAddTab(&tab4);
}
