/*
 * primitives.h
 *
 *  Created on: 08.06.2013
 *      Author: AndreR
 */

#ifndef PRIMITIVES_H_
#define PRIMITIVES_H_

#include "stm32f4xx.h"

typedef struct _PointU16
{
	uint16_t x;
	uint16_t y;
} PointU16;

typedef struct _SizeU16
{
	uint16_t width;
	uint16_t height;
} SizeU16;

typedef struct _RectU16
{
	PointU16 a;
	PointU16 b;
} RectU16;

PointU16	PointU16XY(uint16_t x, uint16_t y);
PointU16	PointU16Add(PointU16 a, PointU16 b);

SizeU16		SizeU16WH(uint16_t width, uint16_t height);

uint32_t	RectU16Size(RectU16* pRect);
RectU16		RectU16Points(PointU16 a, PointU16 b);
RectU16 	RectU16Coordinates(uint16_t ax, uint16_t ay, uint16_t bx, uint16_t by);
RectU16 	RectU16PosSize(PointU16 pos, SizeU16 size);
uint8_t		RectU16IsPointInRect(RectU16 rect, PointU16 p);

#endif /* PRIMITIVES_H_ */
