/**
 ******************************************************************************
 * @file    usb_hcd.h
 * @author  MCD Application Team
 * @version V2.1.0
 * @date    19-March-2012
 * @brief   Host layer Header file
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; COPYRIGHT 2012 STMicroelectronics</center></h2>
 *
 * Licensed under MCD-ST Liberty SW License Agreement V2, (the "License");
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *        http://www.st.com/software_license_agreement_liberty_v2
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USB_HCD_H__
#define __USB_HCD_H__

/* Includes ------------------------------------------------------------------*/
#include "usb_regs.h"
#include "usb_core.h"

uint32_t HCD_Init(USB_OTG_CORE_HANDLE *pdev, USB_OTG_CORE_ID_TypeDef coreID);
uint32_t HCD_HC_Init(USB_OTG_CORE_HANDLE *pdev, uint8_t hc_num);
uint32_t HCD_GetCurrentSpeed(USB_OTG_CORE_HANDLE *pdev);
uint32_t HCD_ResetPort(USB_OTG_CORE_HANDLE *pdev);
uint32_t HCD_IsDeviceConnected(USB_OTG_CORE_HANDLE *pdev);
uint32_t HCD_GetCurrentFrame(USB_OTG_CORE_HANDLE *pdev);
HC_STATUS HCD_GetHCState(USB_OTG_CORE_HANDLE *pdev, uint8_t ch_num);

void URBInit(URB* pURB, uint8_t pipe, uint8_t* pData, uint32_t length, uint32_t flags);
void URBSetCallback(URB* pURB, URBCompleteCallback cb, void* pContext);
uint32_t HCDGetMaxTransferSize(USB_OTG_CORE_HANDLE* pDev, uint8_t pipe);
int16_t HCDSubmitURB(USB_OTG_CORE_HANDLE* pDev, URB* pURB);
void HCDTask(void* params);
int16_t HCDIsPipeActive(USB_OTG_CORE_HANDLE* pDev, uint8_t pipe);

#endif //__USB_HCD_H__
